From 75dca2e84620d79b8a69155d10967761ea543cdf Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 30 2020 04:50:25 +0000
Subject: [PATCH 208/2232] Passing function pointer from Rust to C++


---

diff --git a/gen/write.rs b/gen/write.rs
index 1f7adda..b745739 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -2,7 +2,7 @@ use crate::gen::namespace::Namespace;
 use crate::gen::out::OutFile;
 use crate::gen::{include, Opt};
 use crate::syntax::atom::Atom::{self, *};
-use crate::syntax::{Api, ExternFn, Struct, Type, Types, Var};
+use crate::syntax::{Api, ExternFn, Signature, Struct, Type, Types, Var};
 use proc_macro2::Ident;
 
 pub(super) fn gen(
@@ -109,6 +109,7 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api], types: &Types) {
     let mut needs_rust_string = false;
     let mut needs_rust_str = false;
     let mut needs_rust_box = false;
+    let mut needs_rust_fn = false;
     for ty in types {
         match ty {
             Type::RustBox(_) => {
@@ -120,6 +121,9 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api], types: &Types) {
                 out.include.string = true;
                 needs_rust_str = true;
             }
+            Type::Fn(_) => {
+                needs_rust_fn = true;
+            }
             ty if ty == RustString => {
                 out.include.array = true;
                 out.include.cstdint = true;
@@ -175,6 +179,7 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api], types: &Types) {
     if needs_rust_string
         || needs_rust_str
         || needs_rust_box
+        || needs_rust_fn
         || needs_rust_error
         || needs_unsafe_bitcopy
         || needs_manually_drop
@@ -192,6 +197,7 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api], types: &Types) {
     write_header_section(out, needs_rust_string, "CXXBRIDGE02_RUST_STRING");
     write_header_section(out, needs_rust_str, "CXXBRIDGE02_RUST_STR");
     write_header_section(out, needs_rust_box, "CXXBRIDGE02_RUST_BOX");
+    write_header_section(out, needs_rust_fn, "CXXBRIDGE02_RUST_FN");
     write_header_section(out, needs_rust_error, "CXXBRIDGE02_RUST_ERROR");
     write_header_section(out, needs_unsafe_bitcopy, "CXXBRIDGE02_RUST_BITCOPY");
 
@@ -402,27 +408,71 @@ fn write_cxx_function_shim(out: &mut OutFile, efn: &ExternFn, types: &Types) {
         writeln!(out, "  return throw$;");
     }
     writeln!(out, "}}");
+    for arg in &efn.args {
+        if let Type::Fn(f) = &arg.ty {
+            let var = &arg.ident;
+            write_function_pointer_trampoline(out, efn, var, f, types);
+        }
+    }
+}
+
+fn write_function_pointer_trampoline(
+    out: &mut OutFile,
+    efn: &ExternFn,
+    var: &Ident,
+    f: &Signature,
+    types: &Types,
+) {
+    out.next_section();
+    let r_trampoline = format!("{}cxxbridge02${}${}$1", out.namespace, efn.ident, var);
+    let indirect_call = true;
+    write_rust_function_decl_impl(out, &r_trampoline, f, types, indirect_call);
+
+    out.next_section();
+    let c_trampoline = format!("{}cxxbridge02${}${}$0", out.namespace, efn.ident, var);
+    write_rust_function_shim_impl(out, &c_trampoline, f, types, &r_trampoline, indirect_call);
 }
 
 fn write_rust_function_decl(out: &mut OutFile, efn: &ExternFn, types: &Types) {
-    if efn.throws {
+    let link_name = format!("{}cxxbridge02${}", out.namespace, efn.ident);
+    let indirect_call = false;
+    write_rust_function_decl_impl(out, &link_name, efn, types, indirect_call);
+}
+
+fn write_rust_function_decl_impl(
+    out: &mut OutFile,
+    link_name: &str,
+    sig: &Signature,
+    types: &Types,
+    indirect_call: bool,
+) {
+    if sig.throws {
         write!(out, "::rust::Str::Repr ");
     } else {
-        write_extern_return_type_space(out, &efn.ret, types);
+        write_extern_return_type_space(out, &sig.ret, types);
     }
-    write!(out, "{}cxxbridge02${}(", out.namespace, efn.ident);
-    for (i, arg) in efn.args.iter().enumerate() {
-        if i > 0 {
+    write!(out, "{}(", link_name);
+    let mut needs_comma = false;
+    for arg in &sig.args {
+        if needs_comma {
             write!(out, ", ");
         }
         write_extern_arg(out, arg, types);
+        needs_comma = true;
     }
-    if indirect_return(efn, types) {
-        if !efn.args.is_empty() {
+    if indirect_return(sig, types) {
+        if needs_comma {
             write!(out, ", ");
         }
-        write_return_type(out, &efn.ret);
+        write_return_type(out, &sig.ret);
         write!(out, "*return$");
+        needs_comma = true;
+    }
+    if indirect_call {
+        if needs_comma {
+            write!(out, ", ");
+        }
+        write!(out, "void *");
     }
     writeln!(out, ") noexcept;");
 }
@@ -431,24 +481,44 @@ fn write_rust_function_shim(out: &mut OutFile, efn: &ExternFn, types: &Types) {
     for line in efn.doc.to_string().lines() {
         writeln!(out, "//{}", line);
     }
-    write_return_type(out, &efn.ret);
-    write!(out, "{}(", efn.ident);
-    for (i, arg) in efn.args.iter().enumerate() {
+    let local_name = efn.ident.to_string();
+    let invoke = format!("{}cxxbridge02${}", out.namespace, efn.ident);
+    let indirect_call = false;
+    write_rust_function_shim_impl(out, &local_name, efn, types, &invoke, indirect_call);
+}
+
+fn write_rust_function_shim_impl(
+    out: &mut OutFile,
+    local_name: &str,
+    sig: &Signature,
+    types: &Types,
+    invoke: &str,
+    indirect_call: bool,
+) {
+    write_return_type(out, &sig.ret);
+    write!(out, "{}(", local_name);
+    for (i, arg) in sig.args.iter().enumerate() {
         if i > 0 {
             write!(out, ", ");
         }
         write_type_space(out, &arg.ty);
         write!(out, "{}", arg.ident);
     }
+    if indirect_call {
+        if !sig.args.is_empty() {
+            write!(out, ", ");
+        }
+        write!(out, "void *extern$");
+    }
     write!(out, ")");
-    if !efn.throws {
+    if !sig.throws {
         write!(out, " noexcept");
     }
     if out.header {
         writeln!(out, ";");
     } else {
         writeln!(out, " {{");
-        for arg in &efn.args {
+        for arg in &sig.args {
             if arg.ty != RustString && types.needs_indirect_abi(&arg.ty) {
                 out.include.utility = true;
                 write!(out, "  ::rust::ManuallyDrop<");
@@ -457,13 +527,13 @@ fn write_rust_function_shim(out: &mut OutFile, efn: &ExternFn, types: &Types) {
             }
         }
         write!(out, "  ");
-        let indirect_return = indirect_return(efn, types);
+        let indirect_return = indirect_return(sig, types);
         if indirect_return {
             write!(out, "::rust::MaybeUninit<");
-            write_type(out, efn.ret.as_ref().unwrap());
+            write_type(out, sig.ret.as_ref().unwrap());
             writeln!(out, "> return$;");
             write!(out, "  ");
-        } else if let Some(ret) = &efn.ret {
+        } else if let Some(ret) = &sig.ret {
             write!(out, "return ");
             match ret {
                 Type::RustBox(_) => {
@@ -478,11 +548,11 @@ fn write_rust_function_shim(out: &mut OutFile, efn: &ExternFn, types: &Types) {
                 _ => {}
             }
         }
-        if efn.throws {
+        if sig.throws {
             write!(out, "::rust::Str::Repr error$ = ");
         }
-        write!(out, "{}cxxbridge02${}(", out.namespace, efn.ident);
-        for (i, arg) in efn.args.iter().enumerate() {
+        write!(out, "{}(", invoke);
+        for (i, arg) in sig.args.iter().enumerate() {
             if i > 0 {
                 write!(out, ", ");
             }
@@ -501,19 +571,25 @@ fn write_rust_function_shim(out: &mut OutFile, efn: &ExternFn, types: &Types) {
             }
         }
         if indirect_return {
-            if !efn.args.is_empty() {
+            if !sig.args.is_empty() {
                 write!(out, ", ");
             }
             write!(out, "&return$.value");
         }
+        if indirect_call {
+            if !sig.args.is_empty() || indirect_return {
+                write!(out, ", ");
+            }
+            write!(out, "extern$");
+        }
         write!(out, ")");
-        if let Some(ret) = &efn.ret {
+        if let Some(ret) = &sig.ret {
             if let Type::RustBox(_) | Type::UniquePtr(_) = ret {
                 write!(out, ")");
             }
         }
         writeln!(out, ";");
-        if efn.throws {
+        if sig.throws {
             writeln!(out, "  if (error$.ptr) {{");
             writeln!(out, "    throw ::rust::Error(error$);");
             writeln!(out, "  }}");
@@ -533,10 +609,10 @@ fn write_return_type(out: &mut OutFile, ty: &Option<Type>) {
     }
 }
 
-fn indirect_return(efn: &ExternFn, types: &Types) -> bool {
-    efn.ret
+fn indirect_return(sig: &Signature, types: &Types) -> bool {
+    sig.ret
         .as_ref()
-        .map_or(false, |ret| efn.throws || types.needs_indirect_abi(ret))
+        .map_or(false, |ret| sig.throws || types.needs_indirect_abi(ret))
 }
 
 fn write_indirect_return_type(out: &mut OutFile, ty: &Type) {
@@ -640,7 +716,21 @@ fn write_type(out: &mut OutFile, ty: &Type) {
         Type::Str(_) => {
             write!(out, "::rust::Str");
         }
-        Type::Fn(_) => unimplemented!(),
+        Type::Fn(f) => {
+            write!(out, "::rust::{}<", if f.throws { "TryFn" } else { "Fn" });
+            match &f.ret {
+                Some(ret) => write_type(out, ret),
+                None => write!(out, "void"),
+            }
+            write!(out, "(");
+            for (i, arg) in f.args.iter().enumerate() {
+                if i > 0 {
+                    write!(out, ", ");
+                }
+                write_type(out, &arg.ty);
+            }
+            write!(out, ")>");
+        }
         Type::Void(_) => unreachable!(),
     }
 }
@@ -652,9 +742,10 @@ fn write_type_space(out: &mut OutFile, ty: &Type) {
 
 fn write_space_after_type(out: &mut OutFile, ty: &Type) {
     match ty {
-        Type::Ident(_) | Type::RustBox(_) | Type::UniquePtr(_) | Type::Str(_) => write!(out, " "),
+        Type::Ident(_) | Type::RustBox(_) | Type::UniquePtr(_) | Type::Str(_) | Type::Fn(_) => {
+            write!(out, " ")
+        }
         Type::Ref(_) => {}
-        Type::Fn(_) => unimplemented!(),
         Type::Void(_) => unreachable!(),
     }
 }
diff --git a/include/cxx.h b/include/cxx.h
index 50f8f69..3dd52e5 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -147,6 +147,23 @@ private:
 };
 #endif // CXXBRIDGE02_RUST_BOX
 
+#ifndef CXXBRIDGE02_RUST_FN
+#define CXXBRIDGE02_RUST_FN
+template <typename Signature, bool Throws = false> class Fn;
+
+template <typename Ret, typename... Args, bool Throws>
+class Fn<Ret(Args...), Throws> {
+public:
+  Ret operator()(Args... args) noexcept(!Throws);
+
+private:
+  Ret (*trampoline)(Args..., void *fn) noexcept(!Throws);
+  void *fn;
+};
+
+template <typename Signature> using TryFn = Fn<Signature, true>;
+#endif // CXXBRIDGE02_RUST_FN
+
 #ifndef CXXBRIDGE02_RUST_ERROR
 #define CXXBRIDGE02_RUST_ERROR
 class Error final : std::exception {
@@ -170,6 +187,9 @@ using string = String;
 using str = Str;
 template <class T> using box = Box<T>;
 using error = Error;
+template <typename Signature, bool Throws = false>
+using fn = Fn<Signature, Throws>;
+template <typename Signature> using try_fn = TryFn<Signature>;
 
 #ifndef CXXBRIDGE02_RUST_BITCOPY
 #define CXXBRIDGE02_RUST_BITCOPY
@@ -179,5 +199,10 @@ struct unsafe_bitcopy_t {
 constexpr unsafe_bitcopy_t unsafe_bitcopy{};
 #endif // CXXBRIDGE02_RUST_BITCOPY
 
+template <typename Ret, typename... Args, bool Throws>
+Ret Fn<Ret(Args...), Throws>::operator()(Args... args) noexcept(!Throws) {
+  return (*this->trampoline)(std::move(args)..., this->fn);
+}
+
 } // namespace cxxbridge02
 } // namespace rust
diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 69b7fb5..6afb548 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -1,9 +1,9 @@
 use crate::namespace::Namespace;
 use crate::syntax::atom::Atom::{self, *};
-use crate::syntax::{self, check, Api, ExternFn, ExternType, Struct, Type, Types};
+use crate::syntax::{self, check, Api, ExternFn, ExternType, Signature, Struct, Type, Types};
 use proc_macro2::{Ident, Span, TokenStream};
 use quote::{format_ident, quote, quote_spanned};
-use syn::{Error, ItemMod, Result, Token};
+use syn::{parse_quote, Error, ItemMod, Result, Token};
 
 pub fn bridge(namespace: &Namespace, ffi: ItemMod) -> Result<TokenStream> {
     let ident = &ffi.ident;
@@ -128,6 +128,8 @@ fn expand_cxx_function_decl(namespace: &Namespace, efn: &ExternFn, types: &Types
         let ty = expand_extern_type(&arg.ty);
         if arg.ty == RustString {
             quote!(#ident: *const #ty)
+        } else if let Type::Fn(_) = arg.ty {
+            quote!(#ident: ::cxx::private::FatFunction)
         } else if types.needs_indirect_abi(&arg.ty) {
             quote!(#ident: *mut #ty)
         } else {
@@ -186,6 +188,20 @@ fn expand_cxx_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Types
             _ => quote!(#var),
         }
     });
+    let trampolines = efn
+        .args
+        .iter()
+        .filter_map(|arg| {
+            if let Type::Fn(f) = &arg.ty {
+                let var = &arg.ident;
+                Some(expand_function_pointer_trampoline(
+                    namespace, efn, var, f, types,
+                ))
+            } else {
+                None
+            }
+        })
+        .collect::<TokenStream>();
     let mut setup = efn
         .args
         .iter()
@@ -261,6 +277,7 @@ fn expand_cxx_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Types
             extern "C" {
                 #decl
             }
+            #trampolines
             unsafe {
                 #setup
                 #expr
@@ -269,6 +286,41 @@ fn expand_cxx_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Types
     }
 }
 
+fn expand_function_pointer_trampoline(
+    namespace: &Namespace,
+    efn: &ExternFn,
+    var: &Ident,
+    sig: &Signature,
+    types: &Types,
+) -> TokenStream {
+    let c_trampoline = format!("{}cxxbridge02${}${}$0", namespace, efn.ident, var);
+    let r_trampoline = format!("{}cxxbridge02${}${}$1", namespace, efn.ident, var);
+    let local_name = parse_quote!(__);
+    let catch_unwind_label = format!("::{}::{}", efn.ident, var);
+    let shim = expand_rust_function_shim_impl(
+        sig,
+        types,
+        &r_trampoline,
+        local_name,
+        catch_unwind_label,
+        None,
+    );
+
+    quote! {
+        let #var = ::cxx::private::FatFunction {
+            trampoline: {
+                extern "C" {
+                    #[link_name = #c_trampoline]
+                    fn trampoline();
+                }
+                #shim
+                trampoline as usize as *const ()
+            },
+            ptr: #var as usize as *const (),
+        };
+    }
+}
+
 fn expand_rust_type(ety: &ExternType) -> TokenStream {
     let ident = &ety.ident;
     quote! {
@@ -278,7 +330,29 @@ fn expand_rust_type(ety: &ExternType) -> TokenStream {
 
 fn expand_rust_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Types) -> TokenStream {
     let ident = &efn.ident;
-    let args = efn.args.iter().map(|arg| {
+    let link_name = format!("{}cxxbridge02${}", namespace, ident);
+    let local_name = format_ident!("__{}", ident);
+    let catch_unwind_label = format!("::{}", ident);
+    let invoke = Some(ident);
+    expand_rust_function_shim_impl(
+        efn,
+        types,
+        &link_name,
+        local_name,
+        catch_unwind_label,
+        invoke,
+    )
+}
+
+fn expand_rust_function_shim_impl(
+    sig: &Signature,
+    types: &Types,
+    link_name: &str,
+    local_name: Ident,
+    catch_unwind_label: String,
+    invoke: Option<&Ident>,
+) -> TokenStream {
+    let args = sig.args.iter().map(|arg| {
         let ident = &arg.ident;
         let ty = expand_extern_type(&arg.ty);
         if types.needs_indirect_abi(&arg.ty) {
@@ -287,7 +361,8 @@ fn expand_rust_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Type
             quote!(#ident: #ty)
         }
     });
-    let vars = efn.args.iter().map(|arg| {
+
+    let vars = sig.args.iter().map(|arg| {
         let ident = &arg.ident;
         match &arg.ty {
             Type::Ident(i) if i == RustString => {
@@ -304,9 +379,14 @@ fn expand_rust_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Type
             _ => quote!(#ident),
         }
     });
-    let mut outparam = None;
-    let call = quote!(super::#ident(#(#vars),*));
-    let mut expr = efn
+
+    let mut call = match invoke {
+        Some(ident) => quote!(super::#ident),
+        None => quote!(__extern),
+    };
+    call.extend(quote! { (#(#vars),*) });
+
+    let mut expr = sig
         .ret
         .as_ref()
         .and_then(|ret| match ret {
@@ -325,13 +405,15 @@ fn expand_rust_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Type
             _ => None,
         })
         .unwrap_or(call);
-    let indirect_return = indirect_return(efn, types);
+
+    let mut outparam = None;
+    let indirect_return = indirect_return(sig, types);
     if indirect_return {
-        let ret = expand_extern_type(efn.ret.as_ref().unwrap());
-        outparam = Some(quote!(__return: *mut #ret));
+        let ret = expand_extern_type(sig.ret.as_ref().unwrap());
+        outparam = Some(quote!(__return: *mut #ret,));
     }
-    if efn.throws {
-        let out = match efn.ret {
+    if sig.throws {
+        let out = match sig.ret {
             Some(_) => quote!(__return),
             None => quote!(&mut ()),
         };
@@ -339,19 +421,24 @@ fn expand_rust_function_shim(namespace: &Namespace, efn: &ExternFn, types: &Type
     } else if indirect_return {
         expr = quote!(::std::ptr::write(__return, #expr));
     }
+
     expr = quote!(::cxx::private::catch_unwind(__fn, move || #expr));
-    let ret = if efn.throws {
+
+    let ret = if sig.throws {
         quote!(-> ::cxx::private::Result)
     } else {
-        expand_extern_return_type(&efn.ret, types)
+        expand_extern_return_type(&sig.ret, types)
     };
-    let link_name = format!("{}cxxbridge02${}", namespace, ident);
-    let local_name = format_ident!("__{}", ident);
-    let catch_unwind_label = format!("::{}", ident);
+
+    let pointer = match invoke {
+        None => Some(quote!(__extern: #sig)),
+        Some(_) => None,
+    };
+
     quote! {
         #[doc(hidden)]
         #[export_name = #link_name]
-        unsafe extern "C" fn #local_name(#(#args,)* #outparam) #ret {
+        unsafe extern "C" fn #local_name(#(#args,)* #outparam #pointer) #ret {
             let __fn = concat!(module_path!(), #catch_unwind_label);
             #expr
         }
@@ -457,10 +544,10 @@ fn expand_return_type(ret: &Option<Type>) -> TokenStream {
     }
 }
 
-fn indirect_return(efn: &ExternFn, types: &Types) -> bool {
-    efn.ret
+fn indirect_return(sig: &Signature, types: &Types) -> bool {
+    sig.ret
         .as_ref()
-        .map_or(false, |ret| efn.throws || types.needs_indirect_abi(ret))
+        .map_or(false, |ret| sig.throws || types.needs_indirect_abi(ret))
 }
 
 fn expand_extern_type(ty: &Type) -> TokenStream {
diff --git a/src/function.rs b/src/function.rs
new file mode 100644
index 0000000..1166b3d
--- /dev/null
+++ b/src/function.rs
@@ -0,0 +1,5 @@
+#[repr(C)]
+pub struct FatFunction {
+    pub trampoline: *const (),
+    pub ptr: *const (),
+}
diff --git a/src/lib.rs b/src/lib.rs
index 09326f5..3aaf172 100644
--- a/src/lib.rs
+++ b/src/lib.rs
@@ -356,6 +356,7 @@ mod assert;
 mod cxx_string;
 mod error;
 mod exception;
+mod function;
 mod gen;
 mod opaque;
 mod paths;
@@ -374,6 +375,7 @@ pub use cxxbridge_macro::bridge;
 // Not public API.
 #[doc(hidden)]
 pub mod private {
+    pub use crate::function::FatFunction;
     pub use crate::opaque::Opaque;
     pub use crate::result::{r#try, Result};
     pub use crate::rust_str::RustStr;
diff --git a/syntax/check.rs b/syntax/check.rs
index b44d0cc..2826a85 100644
--- a/syntax/check.rs
+++ b/syntax/check.rs
@@ -1,5 +1,5 @@
 use crate::syntax::atom::Atom::{self, *};
-use crate::syntax::{error, ident, Api, ExternFn, Ref, Struct, Ty1, Type, Types};
+use crate::syntax::{error, ident, Api, ExternFn, Lang, Ref, Struct, Ty1, Type, Types};
 use proc_macro2::{Delimiter, Group, Ident, TokenStream};
 use quote::{quote, ToTokens};
 use std::fmt::Display;
@@ -136,10 +136,12 @@ fn check_api_fn(cx: &mut Check, efn: &ExternFn) {
             cx.error(arg, msg);
         }
         if let Type::Fn(_) = arg.ty {
-            cx.error(
-                arg,
-                "passing a function pointer argument is not implemented yet",
-            );
+            if efn.lang == Lang::Rust {
+                cx.error(
+                    arg,
+                    "passing a function pointer from C++ to Rust is not implemented yet",
+                );
+            }
         }
     }
 
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index 492fc91..7df0110 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -32,6 +32,7 @@ pub mod ffi {
         fn c_take_str(s: &str);
         fn c_take_rust_string(s: String);
         fn c_take_unique_ptr_string(s: UniquePtr<CxxString>);
+        fn c_take_callback(callback: fn(String) -> usize);
 
         fn c_try_return_void() -> Result<()>;
         fn c_try_return_primitive() -> Result<usize>;
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 6384ac1..4aad3a2 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -92,6 +92,10 @@ void c_take_unique_ptr_string(std::unique_ptr<std::string> s) {
   }
 }
 
+void c_take_callback(rust::Fn<size_t(rust::String)> callback) {
+  callback("2020");
+}
+
 void c_try_return_void() {}
 
 size_t c_try_return_primitive() { return 2020; }
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index e0e7624..6713614 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -35,6 +35,7 @@ void c_take_ref_c(const C &c);
 void c_take_str(rust::Str s);
 void c_take_rust_string(rust::String s);
 void c_take_unique_ptr_string(std::unique_ptr<std::string> s);
+void c_take_callback(rust::Fn<size_t(rust::String)> callback);
 
 void c_try_return_void();
 size_t c_try_return_primitive();
diff --git a/tests/test.rs b/tests/test.rs
index 6a6fc3e..f8e9ca8 100644
--- a/tests/test.rs
+++ b/tests/test.rs
@@ -78,6 +78,18 @@ fn test_c_take() {
 }
 
 #[test]
+fn test_c_callback() {
+    fn callback(s: String) -> usize {
+        if s == "2020" {
+            cxx_test_suite_set_correct();
+        }
+        0
+    }
+
+    check!(ffi::c_take_callback(callback));
+}
+
+#[test]
 fn test_c_call_r() {
     fn cxx_run_test() {
         extern "C" {

